diff --git a/libr/anal/var.c b/libr/anal/var.c
index cae506458d0..549f06383da 100644
--- a/libr/anal/var.c
+++ b/libr/anal/var.c
@@ -42,9 +42,10 @@ R_API int r_anal_var_add (RAnal *a, ut64 addr, int scope, int delta, char kind,
 	if (!type) type = "int";
 //eprintf ("VAR ADD 0x%llx  - %d\n", addr, delta);
 	switch (kind) {
-	case 'a':
+	case 'a': // stack-based argument
 	case 'r':
 	case 'v':
+	case 'A': // fastcall based argument
 		break;
 	default:
 		eprintf ("Invalid var kind '%c'\n", kind);
@@ -94,6 +95,7 @@ R_API int r_anal_var_retype (RAnal *a, ut64 addr, int scope, int delta, char kin
 	case 'a':
 	case 'r':
 	case 'v':
+	case 'A':
 		break;
 	default:
 		eprintf ("Invalid var kind '%c'\n", kind);
@@ -434,6 +436,7 @@ R_API void r_anal_var_list_show(RAnal *anal, RAnalFunction *fcn, int kind, int m
 					var->name, var->type, fcn->addr);
 				break;
 			case 'j':
+				//TODO add afA
 				anal->cb_printf ("{\"name\":\"%s\","
 					"\"kind\":\"%s\",\"type\":\"%s\",\"ref\":\"%s%s0x%x\"}",
 					var->name, var->kind=='v'?"var":"arg", var->type,
@@ -442,12 +445,36 @@ R_API void r_anal_var_list_show(RAnal *anal, RAnalFunction *fcn, int kind, int m
 				if (iter->n) anal->cb_printf (",");
 				break;
 			default:
-				anal->cb_printf ("%s %s %s @ %s%s0x%x\n",
-					kind=='v'?"var":"arg",
-					var->type, var->name,
-					anal->reg->name[R_REG_NAME_BP],
-					(kind=='v')?"-":"+",
-					var->delta);
+				switch (kind) {
+				case 'a':
+					anal->cb_printf ("arg %s %s @ %s+0x%x\n",
+						var->type, var->name,
+						anal->reg->name[R_REG_NAME_BP],
+						var->delta);
+					break;
+				case 'v':
+					anal->cb_printf ("var %s %s @ %s-0x%x\n",
+						var->type, var->name,
+						anal->reg->name[R_REG_NAME_BP],
+						var->delta);
+					break;
+				case 'A':
+					if(var->delta==0){
+						anal->cb_printf ("var %s %s @ ecx\n",
+							var->type, var->name);
+					}else if(var->delta ==1){
+						anal->cb_printf ("var %s %s @ edx\n",
+							var->type, var->name);
+					}else{
+						anal->cb_printf ("var %s %s @ %s+0x%x\n",
+							var->type, var->name,
+							anal->reg->name[R_REG_NAME_BP],
+							var->delta);
+					break;
+
+					}
+					break;
+				}
 			}
 		}
 	}
diff --git a/libr/core/cmd_anal.c b/libr/core/cmd_anal.c
index 6626c58fb7d..1ca937e227c 100644
--- a/libr/core/cmd_anal.c
+++ b/libr/core/cmd_anal.c
@@ -35,23 +35,15 @@ static void flag_every_function(RCore *core) {
 static void var_help(RCore *core, char ch) {
 	const char *help_msg[] = {
 		"Usage:", "af[aAv]", " [idx] [type] [name]",
-		"afa", "", "list function arguments",
-		"afa*", "", "list function arguments in commands",
-		"afa", " [idx] [name] ([type])", "define argument N with name and type",
-		"afan", " [old_name] [new_name]", "rename function argument",
-		"afat", " [name] [new_type]", "change type for given argument",
-		"afaj", "", "return list of function arguments in JSON format",
-		"afa-", " [idx]", "delete argument at the given index",
+		"af[aAv]", "", "list stack based/fastcall function arguments, variables",
+		"af[aAv]*", "", "same as af[aAv] but in r2 commands",
+		"af[aAv]", " [idx] [name] ([type])", "define argument/variable with name and type and offset id",
+		"af[aAv]n", " [old_name] [new_name]", "rename function argument / variable",
+		"af[aAv]t", " [name] [new_type]", "change type for given argument / variable",
+		"af[aAv]j", "", "return list of function arguments /variables in JSON format",
+		"af[aAv]-", " [idx]", "delete argument/ variables at the given index",
 		"afag", " [idx] [addr]", "define var get reference",
 		"afas", " [idx] [addr]", "define var set reference",
-		"afv", "", "list function local variables",
-		"afv*", "", "list function local variables in commands",
-		"afv", " [idx] [name] ([type])", "define variable N with name and type",
-		"afvn", " [old_name] [new_name]", "rename local variable",
-		"afvt", " [name] [new_type]", "change type for given variable",
-		"afvj", "", "return list of function local variables in JSON format",
-		"afv-", " [idx]", "delete variable at the given index",
-		"afvg", " [idx] [addr]", "define var get reference",
 		"afvs", " [idx] [addr]", "define var set reference",
 		"afx", "[-] [from] [to]", "manipulate function xrefs",
 		NULL };
@@ -101,7 +93,7 @@ static int var_cmd(RCore *core, const char *str) {
 		case '.':
 			r_anal_var_list_show (core->anal, fcn, core->offset, 0);
 			break;
-		case '-': // "afv-"
+		case '-': // "afaAv-"
 			if (str[2] == '*') {
 				r_anal_var_delete_all (core->anal, fcn->addr, type);
 			} else {
diff --git a/libr/core/disasm.c b/libr/core/disasm.c
index 7b338c32e89..42478b37008 100644
--- a/libr/core/disasm.c
+++ b/libr/core/disasm.c
@@ -928,7 +928,7 @@ static void handle_show_functions(RCore *core, RDisasmState *ds) {
 	ds->stackptr = 0;
 	if (ds->vars) {
 		char spaces[32];
-		RList *args = r_anal_var_list (core->anal, f, 'a');
+		RList *args = r_anal_var_list (core->anal, f,f->call==R_ANAL_CC_TYPE_FASTCALL?'A':'a');
 		RList *vars = r_anal_var_list (core->anal, f, 'v');
 		r_list_sort (args, (RListComparator)var_comparator);
 		r_list_sort (vars, (RListComparator)var_comparator);
@@ -948,13 +948,36 @@ static void handle_show_functions(RCore *core, RDisasmState *ds) {
 				handle_print_offset (core, ds);
 				r_cons_printf ("     ");
 			}
-			r_cons_printf ("%s; %s %s %s %s@ %s%s0x%x%s\n",
-				COLOR (ds, color_other),
-				(var->kind == 'v') ? "var" : "arg",
-				var->type, var->name, spaces,
-				core->anal->reg->name[R_REG_NAME_BP],
-				(var->kind == 'v') ? "-" : "+",
-				var->delta, COLOR_RESET (ds));
+			r_cons_printf ("%s; ", COLOR (ds, color_other));
+			switch (var->kind) {
+			case 'a':
+				r_cons_printf ("arg %s %s @ %s+0x%x",
+					var->type, var->name,
+					core->anal->reg->name[R_REG_NAME_BP],
+					var->delta);
+				break;
+			case 'v':
+				r_cons_printf ("var %s %s @ %s-0x%x",
+					var->type, var->name,
+					core->anal->reg->name[R_REG_NAME_BP],
+					var->delta);
+				break;
+			case 'A':
+				if(var->delta==0){
+					r_cons_printf ("arg %s %s @ ecx",
+						var->type, var->name);
+				}else if(var->delta ==1){
+					r_cons_printf ("arg %s %s @ edx",
+						var->type, var->name);
+				}else{
+					r_cons_printf ("arg %s %s @ %s+0x%x",
+						var->type, var->name,
+						core->anal->reg->name[R_REG_NAME_BP],
+						var->delta);
+				}
+				break;
+		}
+			r_cons_printf ("%s\n", COLOR_RESET (ds));
 		}
 		r_list_free (vars);
 		// it's already empty, but rlist instance is still there
